Unexpected value of Time#iso8601 with floating point argument.

02/28/2012 04:16 PM - phasis68 (Heesob Park)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.0.0dev (2012-02-21 trunk 34712)

[i386-mswin32_100]

Backport:  

Description

I found Time#iso8601 returns unexpected value in case of floating point argument.

C:>irb

irb(main):001:0> require 'time'

=> true

irb(main):002:0> a = Time.now

=> 2012-02-28 16:12:18 +0900

irb(main):003:0> a.iso8601(10)

=> "2012-02-28T16:12:18.3203750000+09:00"

irb(main):004:0> a.iso8601(1)

=> "2012-02-28T16:12:18.3+09:00"

irb(main):005:0> a.iso8601(1.5)

=> "2012-02-28T16:12:18.10+09:00"

irb(main):006:0> a.iso8601(1.6)

=> "2012-02-28T16:12:18.12+09:00"

irb(main):007:0> a.iso8601(1.7)

=> "2012-02-28T16:12:18.16+09:00"

irb(main):008:0> a.iso8601(1.8)

=> "2012-02-28T16:12:18.20+09:00"

irb(main):009:0> a.iso8601(2)

=> "2012-02-28T16:12:18.32+09:00"

irb(main):010:0> a.iso8601(2.1)

=> "2012-02-28T16:12:18.40+09:00"

By the way, In ruby 1.8.7, it works as expected.

$ irb

irb(main):001:0> require 'time'

=> true

irb(main):002:0> a = Time.now

=> Tue Feb 28 16:14:07 +0900 2012

irb(main):003:0> a.iso8601(10)

=> "2012-02-28T16:14:07.3405450000+09:00"

irb(main):004:0> a.iso8601(1)

=> "2012-02-28T16:14:07.3+09:00"

irb(main):005:0> a.iso8601(1.1)

=> "2012-02-28T16:14:07.3+09:00"

irb(main):006:0> a.iso8601(1.5)

=> "2012-02-28T16:14:07.3+09:00"

irb(main):007:0> a.iso8601(1.9)

=> "2012-02-28T16:14:07.3+09:00"

irb(main):008:0> a.iso8601(2)

=> "2012-02-28T16:14:07.34+09:00"

irb(main):010:0> a.iso8601(2.1)

=> "2012-02-28T16:14:07.34+09:00"

Associated revisions

Revision 007b7fcdcf709cbffb2ee2c6c01f9edf4daaccac - 02/28/2012 08:16 AM - nobu (Nobuyoshi Nakada)

lib/time.rb (Time#xmlschema): use strftime specifiers instead of
fractional exponential calcuation which yields undesirable

result.  [ruby-core:42997][Bug #6100]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34845 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 007b7fcd - 02/28/2012 08:16 AM - nobu (Nobuyoshi Nakada)

lib/time.rb (Time#xmlschema): use strftime specifiers instead of

fractional exponential calcuation which yields undesirable

result.  [ruby-core:42997][Bug #6100]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34845 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/28/2012 05:16 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r34845.

Heesob, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

lib/time.rb (Time#xmlschema): use strftime specifiers instead of

fractional exponential calcuation which yields undesirable

result.  [ruby-core:42997][Bug #6100]

Powered by TCPDF (www.tcpdf.org)

06/15/2025 2/2

bugs.ruby-lang.org/issues/6100
https://bugs.ruby-lang.org/issues/6100
http://www.tcpdf.org

